"""
    Functions to generate OpenFOAM cases

    The case files are generated by applying string interpolation to an instance of :class:`string.Template` with the given values.
"""

# Copyright (C) 2021 OST Ostschweizer Fachhochschule
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

# Author: Juan Pablo Carbajal <ajuanpi+dev@gmail.com>
import re

from pathlib import Path
from string import Template

template_extension = 'tmpl'
template_delimiter = '@'


class CaseTemplate(Template):
    """ String template with arbitrary delimiter.
    """

    delimiter = template_delimiter


def get_template_files(casefolder):
    """ Find all template files within the case folder.
    """
    return tuple(casefolder.glob(f'**/*.{template_extension}'))


def template_from_file(file):
    """ Create a :class:`CaseTemplate` using the contents of a file.

        Parameters
        ----------
        file: :class:`pathlib.Path`
            Path to templated case file.

        Returns
        -------
        :class:`.CaseTemplate`
    """
    return CaseTemplate(file.read_text())


def file_from_template(file, *, output=False, **kwargs):
    """ Create a case file from a templated file.

        Parameters
        ----------
        file: :class:`pathlib.Path`
            Path to templated case file.
        output: :class:`pathlib.Path` or :class:`bool`
            If False no file is created and the content of the file is returned
            as a string.
            If True, the content is written to an output file with the same name
            as ``file`` without extension.
            If output is a directory, the same as above but in the given the output
            file is written in the given directory.
            Alternative a path to the output case file can be given. In this case
            the output is written to that file.
            The default is False.
        **kwargs
            Arbitrary keyword arguments. If the keyword is in the template
            it will be substituted, otherwise it will be ignored.

        Returns
        -------
        :class:`str`
            Content of the file.
        :class:`pathlib.Path`
            Path to output file. It is None if :attr:`output` was False.
    """

    tpml_str = template_from_file(file)
    content = tpml_str.substitute(**kwargs)
    if output:
        if isinstance(output, bool):
            output = Path(file.with_suffix(''))
        if output.is_dir():
            output = (output / file.name).with_suffix('')
        output.write_text(content)
    else:
        output = None
    return content, output


def get_template_keywords(tpml):
    """ Get keywords from a string template.

        The returned keywords do not include OpenFOAM macro keywords (those
        starting with `$`), only keywords starting with the character
        defined by :obj:`.template_delimiter` are captured.

        Parameters
        ----------
        tpml: :class:`.CaseTemplate`
            String template from which to extract keywords

        Returns
        -------
        :class:`tuple`
            The set of keywords found in the template, sorted alphabetically.

        Example
        -------
        >>> t = CaseTemplate('first: @a; second : @b used twice @b')
        >>> get_template_keywords(t)
        ('a', 'b')
        >>> t = CaseTemplate('@a @b OpenFOAM: $a ${b} ${${c}} $subdict.a $..a $:a')
        >>> get_template_keywords(t)
        ('a', 'b')
        >>> t = CaseTemplate('@a OpenFOAM: $b')
        >>> get_template_keywords(t)
        ('a',)
    """
    return tuple(sorted(set(mo.group('named') or mo.group('braced') for mo in
                            tpml.pattern.finditer(tpml.template))))


def get_of_keywords_from_template(tmpl) -> tuple:
    """Get OF keywords from a string template.

    Only gets the OF keywords linked to the template keywords.
    """
    # Match words followed by delimieter
    regex = re.compile(rf"^\s*?(\w+)\s*?(?=[{template_delimiter}])", re.MULTILINE|re.DOTALL)
    return tuple(m[0].strip() for m in regex.finditer(tmpl.template))

def tree(dir_path: Path, prefix: str = ''):
    """Visual tree structure of given directory Path object. """

    space = '    '
    branch = '│   '
    tee = '├── '
    last = '└── '

    contents = list(dir_path.iterdir())

    # contents each get pointers that are ├── with a final └── :
    pointers = [tee] * (len(contents) - 1) + [last]
    for pointer, path in zip(pointers, contents):
        yield prefix + pointer + path.name
        if path.is_dir():  # extend the prefix and recurse:
            extension = branch if pointer == tee else space
            # i.e. space because last, └── , above so no more |
            yield from tree(path, prefix=prefix+extension)
